<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Merlin Node Status Widget
 *
 * @package    NINJA
 * @author     op5 AB
 * @license    GPL
 */
class Tac_merlin_node_status_Widget extends widget_Base {
	protected $duplicatable = true;
	public function options()
	{
		$options = parent::options();
		$options[] = new option('tac_merlin_node_status', 'display_checks', 'Display Checks', 'checkbox', array(), true);
		$options[] = new option('tac_merlin_node_status', 'display_latency', 'Display Latency', 'checkbox', array(), true);
		return $options;
	}
	public function index()
	{
		$this->js = array('/js/tac_merlin_node_status');

		# don't show anything if user isn't authorized to see
		$auth = new Nagios_auth_Model();
		if (!$auth->authorized_for_system_information) {
			return;
		}

		# fetch widget view path
		$view_path = $this->view_path('view');

		$current_status = $this->get_current_status();
		$arguments = $this->get_arguments();

		$sock = socket_create(AF_UNIX, SOCK_STREAM, 0);
		socket_connect($sock, '/opt/monitor/var/rw/nagios.qh');
		socket_write($sock, "#merlin nodeinfo\000");
		$resp = '';
		while (($out = socket_read($sock, 4096)) != false)
			$resp .= $out;
		socket_close($sock);

		$nodes = array();
		foreach (split("\n", $resp) as $row) {
			if (empty($row))
				continue;
			$node = array();
			foreach (split(";", $row) as $keyval) {
				list($key, $val) = split('=', $keyval);
				$node[$key] = $val;
			}
			$nodes[] = $node;
		}
		# fetch widget content.
		require($view_path);
	}
}
